require "import"
import "com.androlua.*"
import "android.widget.*"
import "android.widget.ListView"
import "android.widget.ArrayAdapter"
import "android.view.*"
import "android.net.Uri"
import "android.content.Intent"
json=require "cjson"
import "luajava"
import "android.os.Environment"
local folderPath = "/storage/emulated/0/解说/Plugins"
local oldFolderName = "4"
local newFolderName = "Tools Space, v2.0"
os.rename(folderPath .. "/" .. oldFolderName, folderPath .. "/" .. newFolderName)
local folderPath = "/sdcard/解说/Plugins"
local oldFolderName = "4"
local newFolderName = "Tools Space, v2.0"
os.rename(folderPath .. "/" .. oldFolderName, folderPath .. "/" .. newFolderName)

layout = {
  GridView,
  id = "grid",
  numColumns = 1,
  layout_width = "fill",
  layout_height = "fill"
}

items = {
  "إنشاءُ رابطٍ لِحسابِ Telegram",
  "إنشاءُ رابطٍ لِحسابِ WhatsApp",
  "إنشاءُ روابِطِ التحميلِ المُباشَرة",
  "أحوالُ الطقس",
  "نَسْخُ رابطِ التطبيقِ المَفتوحِ إلى الحافِظة",
  "مُوَلِّدُ كلماتِ المرور",
  "مُحَوِّلُ التاريخ",
  "القُرْعةُ العشوائية",
  "حِسابُ العُمُر",
  "مُحَلِّلُ النص",
  "حَجَرة ورقة مقص",
  "الموسوعةُ الحديثية",
  "المِسْبَحةُ الإلكترونية",

}

helpMenu = {
  "ما الجديد؟",
  "تغييرُ ترتيبِ الأدوات",
  "قناتُنا على YouTube",
  "قناتُنا على Telegram",
}

function showHelpDialog()
  local helpMessage = "أهلاً وسهلاً بِكَ في Tools Space، جميعُ الأدواتِ المفيدةِ في مكانٍ واحد.\nالإصدار: 1.2.\nتطوير:محمد إبراهيم ومحمد لؤي من فريقِ كوكب المكفوفين التقني."
  helpDialog = LuaDialog(this)
  helpDialog.View = loadlayout(layout)
  grid.adapter = SingleLineAdapter(service, String(helpMenu))
  helpDialog.setTitle("مساعدة")
  helpDialog.setMessage(helpMessage)
  helpDialog.setPositiveButton("خروج", nil)
  helpDialog.show()
  grid.onItemClick = function(l, v)
  task(500, function()
    if v.text == "ما الجديد؟" then 
      showNew()  
    helpDialog = LuaDialog(this)
    helpDialog.setTitle("ما الجديد")
    helpDialog.setView(loadlayout(InputLayout)) 
    helpDialog.show()
    elseif v.text == "تغييرُ ترتيبِ الأدوات" then  
      changeToolsOrder()
    helpDialog = LuaDialog(this)
    helpDialog.setTitle("تغييرُ ترتيبِ الأزرار")
    helpDialog.setView(loadlayout(InputLayout))
    helpDialog.show()
    elseif v.text == "قناتُنا على YouTube" then
      this.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse("https://youtube.com/@PlanetBlindTech?si=X2hj0BRQ2LIUE_zD")))
      service.click({{"%العودة"}})           
      service.postClick(20, {{helpDialog.dismiss()}})
    elseif v.text == "قناتُنا على Telegram" then
      this.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse("https://t.me/mohammad_loay222")))
      service.click({{"%العودة"}})           
      service.postClick(20, {{helpDialog.dismiss()}})
end
end)
end
end

dlg = LuaDialog(this)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(items))
dlg.setTitle("Tools Space")
dlg.setButton("مساعدة", {
  onClick = function()
    showHelpDialog()
  end
})
dlg.setButton2("خروج", {
  onClick = function()
    dlg.dismiss()
  end
})
dlg.show()
grid.onItemClick = function(l, v)
  task(500, function()
    if v.text == "إنشاءُ رابطٍ لِحسابِ Telegram" then 
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "أَدْخِل اسمَ المُسْتخدِمِ بدونِ @";
          id = "edit";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "مراسَلةُ الحساب";
          onClick = function()
            if edit.text == "" then
              service.speak("أَدْخِل اسمَ المُسْتخدِمِ وأََعِِِد المحاولة")
            else
              this.startActivity(Intent(Intent.ACTION_VIEW,
              Uri.parse("https://t.me/"..edit.text)))
              service.click({{"%العودة"}})
              service.playSoundTick()
              service.postClick(20, {{dlg.dismiss()}})            
            end
          end
        };
        {
          Button;
          text = "إنشاءُ رابطٍ ونَسْخُه";
          onClick = function()
            if edit.text == "" then
              service.speak("أَدْخِل اسمَ المُسْتخدِمِ وأَعِِد المحاولة")
            else
              service.copy("https://t.me/"..edit.text)
              service.postSpeak(100, "أُنْشِئَ الرابطُ وَنُسِخَ إلى الحافِظة")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end
        };
      }
    dlg = LuaDialog(this)
    dlg.setTitle("إنشاءُ رابطٍ لِحسابِ Telegram")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    elseif v.text == "إنشاءُ رابطٍ لِحسابِ WhatsApp" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "مِثال: 966500123456";
          id = "edit";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";        
        };
        {
          EditText;
          hint = "الرسالة";
          id = "messageEdit";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "مراسَلةُ الحساب";
          onClick = function()
            if edit.text == "" then
              service.speak("أَدْخِل رقمَ الهاتفِ وأَعِد المحاولة")
            else
              local phoneNumber = edit.text
              local message = messageEdit.getText().toString()
              local whatsappUrl = "https://wa.me/" .. phoneNumber
            if message ~= "" then
              whatsappUrl = whatsappUrl .. "?text=" .. message
            end
            this.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse(whatsappUrl)))
            service.click({{"%العودة"}})
            service.playSoundTick()
            service.postClick(20, {{"dlg.dismiss()"}})
          end
        end
      };
        {
          Button;
          text = "إنشاءُ رابطٍ ونَسْخُه";
          onClick = function()
            if edit.text == "" then
              service.speak("أَدْخِل رقمَ الهاتفِ وأَعِد المحاولة")
            else
              local phoneNumber = edit.text
              local message = messageEdit.getText().toString()
              local whatsappUrl = "https://wa.me/" .. phoneNumber
            if message ~= "" then
              whatsappUrl = whatsappUrl .. "?text=" .. message
            end
            service.copy(whatsappUrl)
            service.postSpeak(100, "أُنْشِئَ الرابطُ ونُسِخَ إلى الحافِظة")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end
        };
      }
    dlg = LuaDialog(this)
    dlg.setTitle("إنشاءُ رابطٍ لِحسابِ WhatsApp")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    elseif v.text == "إنشاءُ روابِطِ التحميلِ المُباشَرة" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "أدخِلْ رابِطاً";
          gravity = "right";
          layout_width = "match_parent";
          id = "linkEditText";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "إنشاء";
          onClick = function(v)
            local linkEditText = dlg.findViewById(linkEditText.getId())
            local link = linkEditText.getText().toString()        
            if string.find(link, "dropbox%.com") and string.find(link, "dl=0") then
              link = link:gsub("dl=0", "dl=1")
              print(link)               
            elseif string.find(link, "drive%.google%.com/file/d/") then
              link = link:gsub("drive%.google%.com/file/d/", "drive.google.com/uc?export=download&id=")          
              link = link:gsub("/v.-$", "")
              print(link)
            else
              service.speak("أَدْخِل رابطاً صحيحاً ثم أعِد المحاولة.")
            end
          end;
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }
    dlg = LuaDialog(this)
    dlg.setTitle("إنشاءُ روابِطِ التحميلِ المُباشَرة")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    elseif v.text == "أحوالُ الطقس" then
      import "android.content.*"
      dlg.dismiss()
      intent = Intent(Intent.ACTION_MAIN)
      intent.setComponent(ComponentName(
        "com.google.android.googlequicksearchbox",
        "com.google.android.apps.search.weather.WeatherExportedActivity"
      ))
      this.startActivity(intent)           return true
    elseif v.text == "نَسْخُ رابطِ التطبيقِ المَفتوحِ إلى الحافِظة" then
    dlg.dismiss()
      local appName = this.getAppName(node)
      local appPackage = node.getPackageName()
      local appUrl = 'https://play.google.com/store/apps/details?id=' .. appPackage
      service.copy('رابط تطبيق\n' .. appName .. '\n' .. appUrl)
      service.postSpeak(300, 'نُسِخَ رابطُ تطبيقِ ' .. appName .. ' إلى الحافظة')
      dlg.dismiss()
    elseif v.text == "مُوَلِّدُ كلماتِ المرور" then
      passwordGeneratorLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          TextView;
          text = "طولُ كلمةِ المرور:";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          EditText;
          hint = "أَدْخِل طُوْلَ كلمةِ المرور";
          id = "passwordLengthEdit";
          inputType = "phone";

          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
  
        };
        {
          CheckBox;
          text = "تضمينُ أحْرُفٍ كبيرة";
          id = "includeUppercaseCheckbox";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
   
        };
        {
          CheckBox;
          text = "تضمينُ أحْرُفٍ صغيرة";
          id = "includeLowercaseCheckbox";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";   
        };
        {
          CheckBox;
          text = "تضمينُ أرقام";
          id = "includeNumbersCheckbox";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
   

        };
        {CheckBox;
          text = "تضمينُ الرموز";
          id = "includeSpecialCharsCheckbox";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
   
        };
        {
          CheckBox;
          text = "نَسْخُ كلمةِ المرورِ إلى الحافِظة";
          gravity = "right";
          layout_width = "match_parent";   
          id = "copyPasswordCheckbox";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";

        };
        {
          Button;
          text = "إنشاءُ كلمةِ المرور";
          onClick = function()
            local passwordLength = tonumber(passwordLengthEdit.text)
            local includeUppercase = includeUppercaseCheckbox.isChecked()
            local includeLowercase = includeLowercaseCheckbox.isChecked()
            local includeNumbers = includeNumbersCheckbox.isChecked()
            local includeSpecialChars = includeSpecialCharsCheckbox.isChecked()
            local copyPassword = copyPasswordCheckbox.isChecked()

            if passwordLength then
              local chars = ""
              if includeUppercase then
                chars = chars .. "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
              end
              if includeLowercase then
                chars = chars .. "abcdefghijklmnopqrstuvwxyz"
              end
              if includeNumbers then
                chars = chars .. "0123456789"
              end
              if includeSpecialChars then
                chars = chars .. "!@#$%^&*()_+[]{}|;:,.<>?~"
              end

              if chars == "" then
                service.speak("حدِّد خياراً واحداً على الأقل")
              else
                local password = ""
                for i = 1, passwordLength do
                  local randomIndex = math.random(1, #chars)
                  password = password .. chars:sub(randomIndex, randomIndex)
                end
                print("كلمةُ المرورِ العشوائيةِ هِيَ:", password)
                if copyPassword then
                  service.copy(password)
                end
              end
            else
              service.speak("أدْخِل طولَ كلمةِ المرور")
            end
          end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }

    dlg = LuaDialog(this)
    dlg.setTitle("مُوَلِّدُ كلماتِ المرور")
    dlg.setView(loadlayout(passwordGeneratorLayout))
    dlg.show()
    elseif v.text == "مُحَوِّلُ التاريخ" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "اليوم";
          id = "day";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          EditText;
          hint = "الشهر";
          id = "month";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";          
        };
        {
          EditText;
          hint = "السنة";
          id = "year";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "تحويلُ التاريخِ الحالي";
          onClick = function()
            local d = os.date("*t")
            local date = d.day.."-"..d.month.."-"..d.year
            local url = "http://api.aladhan.com/v1/gToH/"..date
            Http.get(url,function(status, data)
            if status == 200 then
              local jdata = json.decode(data)
              local result = {
                hijri = {
                  date = jdata["data"]["hijri"]["date"],
                  day = string.sub(jdata["data"]["hijri"]["date"], 1, 2),
                  month = jdata["data"]["hijri"]["month"]["ar"],
                  year = string.sub(jdata["data"]["hijri"]["date"], 7),
                },
              }
              service.speak(result["hijri"]["day"].. " ".. result["hijri"]["month"].. " ".. result["hijri"]["year"])             
            else
              service.speak("عُذراً، حدثَ خَطَأ، أعِدِ المُحاولة، قد تكونُ المُشكِلةُ في أنَّكَ أدْخَلْتَ قيمةً خاطئة، أو أنَّكَ غيرُ مُتَّصِلٍ بالإنترنت.")
            end
          end)
        end
        };
        {
          Button;
          text = "تحويل";
          onClick = function()
            local day = day.text
            local month = month.text
            local year = year.text
            local date = day.."-"..month.."-"..year
            local url = "http://api.aladhan.com/v1/gToH/"..date
            Http.get(url,function(status, data)
            if status == 200 then
            local jdata = json.decode(data)
            local result = {
              hijri = {
                date = jdata["data"]["hijri"]["date"],
                day = string.sub(jdata["data"]["hijri"]["date"], 1, 2),
                month = jdata["data"]["hijri"]["month"]["ar"],
                year = string.sub(jdata["data"]["hijri"]["date"], 7),
              },
            }
            service.speak(result["hijri"]["day"].. " ".. result["hijri"]["month"].. " ".. result["hijri"]["year"])
          else
            service.speak("عُذراً، حدثَ خَطَأ، أعِدِ المُحاولة، قد تكونُ المُشكِلةُ في أنَّكَ أدْخَلْتَ قيمةً خاطئة، أو أنَّكَ غيرُ مُتَّصِلٍ بالإنترنت.")
          end
        end)
      end;
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }
    dlg = LuaDialog()
    dlg.setTitle("مُحَوِّلُ التاريخ")
    dlg.setView(loadlayout(InputLayout))    
    dlg.show()    
    elseif v.text == "القُرْعةُ العشوائية" then
        InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "أَدْخِل الأسماء (مفصولةً بِنُقاط)";
          id = "valuesEdit";          
          gravity = "right";
          inputType = "text";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";          
        };
        {
          EditText;
          hint = "عددُ الفائزين";
          id = "winnersNum";
          inputType = "phone";
          text = "1";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";                    
       };
        {
          Button;
          text = "سَحْب";
          onClick = function()
            local values = valuesEdit.text
            local winnersNum = tonumber(winnersNum.text)
            local valueList = {}
            local winners = {} 
            if values == "" then
              service.speak("حدثَ خطَأٌ ما، أَعِد المحاولة.")            
            elseif not winnersNum then
              service.speak("حدثَ خطَأٌ ما، أَعِد المحاولة.")             
            elseif valuesEdit and winnersNum then            
              for value in string.gmatch(values, "[^.]+") do
                table.insert(valueList, value)
              end                            
              if winnersNum <= #valueList then            
                for i = 1, winnersNum do
                  local randomIndex = math.random(1, #valueList)
                  table.insert(winners, valueList[randomIndex])
                  table.remove(valueList, randomIndex) 
                end                         
              if #winners == 1 then
                service.speak("الفائِزُ هُوَ: "..table.concat(winners, "،"))                            
              elseif #winners > 1 then
                service.speak("الفائِزونَ هم: "..table.concat(winners, "،"))
              end
              if winnersNum == 0 then
                service.speak("لا يُمْكِنُ أن يكونَ عددُ الفائِزينَ صِفْر.")
              end
              else
                service.speak("عددُ الفائِزينَ المُدْخَلُ أكبرُ مِن عَدَدِ المُتسابقين، أعِد المحاولة.") 
              end
            end
          end;
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }
    dlg = LuaDialog()
    dlg.setTitle("القُرْعةُ العشوائية")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()     
    dlg.show()
    elseif v.text == "حِسابُ العُمُر" then  
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "اليوم";
          id = "day";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";          
        };
        {
          EditText;
          hint = "الشهر";
          id = "month";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";          
        };
        {
          EditText;
          hint = "السنة";
          id = "year";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          EditText;
          hint = "الساعة";
          id = "hour";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          EditText;
          hint = "الدقيقة";
          id = "minute";
          inputType = "phone";
          gravity = "right";
          layout_width = "match_parent";   
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "اِحْسِِب عُمُرَكْ";
          onClick = function()
            local day = tonumber(day.text)
            local month = tonumber(month.text)
            local year = tonumber(year.text)
            local hour = tonumber(hour.text)
            local minute = tonumber(minute.text)
        
            if not day or not month or not year then
              service.speak(" حَدَثَ خَطأٌ ما، أعِدِ المُحاولة.")
              return
            end

            if os.time({year=year, month=month, day=day}) > os.time() then
              service.speak(" يرجى إدخال تاريخ صحيح.")
              return
            end
            if hour == nil then
              hour = 0
            end
            if minutes == nil then
              minutes = 0
            end
        
            if year < 0 or month < 0 or day < 0 then
              service.speak(" يرجى إدخال تاريخ صحيح.")
              return
            end

            local function calculateAge(birthDate)
              local currentDate = os.date("*t")
              local birthTime = os.time({year = birthDate.year, month = birthDate.month, day = birthDate.day, hour = hour, min = minute})
              local currentTime = os.time()          
              local diffInSeconds = os.difftime(currentTime, birthTime)
              local years = math.floor(diffInSeconds / (60 * 60 * 24 * 365.25))
              local months = math.floor((diffInSeconds % (60 * 60 * 24 * 365.25)) / (60 * 60 * 24 * 30.44))
              local days = math.floor((diffInSeconds % (60 * 60 * 24 * 30.44)) / (60 * 60 * 24))
              local hours = math.floor((diffInSeconds % (60 * 60 * 24)) / (60 * 60))
              local minutes = math.floor((diffInSeconds % (60 * 60)) / 60)          
              return years, months, days, hours, minutes
            end

            local birthDate = {day = day, month = month, year = year}
            local years, months, days, hours, minutes = calculateAge(birthDate)        
            local yearsResult, monthsResult, daysResult, hoursResult, minutesResult
        
            if years == 1 then
              yearsResult = "عامٌ واحدٌ"
            elseif years == 2 then
              yearsResult = "عامانِ"
            elseif years <= 10 and years >= 3 then
              yearsResult = years .. " أعوامٍ"
            else
              yearsResult = years .. " عاماً"
            end
        
            if months == 1 then
              monthsResult = "شهرٌ واحدٌ"
            elseif months == 2 then
              monthsResult = "شهرانِ"
            elseif months <= 10 and months >= 3 then
              monthsResult = months .. " أشْهُرٍ"
            else
              monthsResult = months .. " شَهْراً"
            end

            if days == 1 then
              daysResult = "يومٌ واحدٌ"
            elseif days == 2 then
              daysResult = "يَوْمانِ"
            elseif days <= 10 and days >= 3 then
              daysResult = days .. " أَيَّامٍ"
            else
              daysResult = days .. " يوماً"
            end
        
            if hours == 1 then
              hoursResult = "ساعةٌ واحدةٌ"
            elseif hours == 2 then
              hoursResult = "ساعَتَان"
            elseif hours <= 10 and hours >= 3 then
              hoursResult = hours .. " ساعاتٍ"
            else
              hoursResult = hours .. " ساعةً"
            end
        
            if minutes == 1 then
              minutesResult = "دقيقةٌ واحدة"
            elseif minutes == 2 then
              minutesResult = "دَقِيقَتَان"
            elseif minutes <= 10 and minutes >= 3 then
              minutesResult = minutes.." دقائق"
            else
              minutesResult = minutes .. " دقيقة"
            end
           
            local dayOfWeek = os.date("%A", os.time({year = year, month = month, day = day}))
            if dayOfWeek == "Friday" then
              dayOfWeek = "الجمعة"
            elseif dayOfWeek == "Saturday" then
              dayOfWeek = "السبت"
            elseif dayOfWeek == "Sunday" then
              dayOfWeek = "الأحد"
            elseif dayOfWeek == "Monday" then
              dayOfWeek = "الاثنَين"
            elseif dayOfWeek == "Tuesday" then
              dayOfWeek = "الثُّلَاثاءء"
            elseif dayOfWeek == "Wednesday" then
              dayOfWeek = "الأربعاء"
            elseif dayOfWeek == "Thursday" then
              dayOfWeek = "الخميس" 
            end
            service.speak("وُلِدْتَ في يومِ " .. dayOfWeek .. " وَعُمُرُكَ الآنَ هوَ: " .. yearsResult .. " و" .. monthsResult .. " و" .. daysResult .. " و" .. hoursResult .. " و" .. minutesResult)
          end;
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }
    dlg = LuaDialog(this)
    dlg.setTitle("حِسابُ العُمُر")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    elseif v.text == "مُحَلِّلُ النص" then
      InputLayout = {
        ScrollView; -- استخدم ScrollView للتمكن من التمرير إذا كان النص طويلًا
        {
          LinearLayout;
          orientation = "vertical";
          layout_width = "match_parent";
          {
            EditText;
            hint = "أدخِل النص هنا";
            id = "text";
            gravity = "right";
            layout_width = "match_parent";
            layout_marginLeft = "11dp";
            layout_marginRight = "16dp";
          };            
          {
            Button;
            text = "تحليل";
            onClick = function()
              local text = text.text
              function analyzeText(text)
              local charCount = string.len(text)
              local charCountWithoutSpaces = 0
    
              for char in text:gmatch("[%z\1-\127\194-\244][\128-\191]*") do
                if char ~= " " then
                  charCountWithoutSpaces = charCountWithoutSpaces + 1
                end
              end
    
              local wordCount = 0
              for _ in text:gmatch("%S+") do
                wordCount = wordCount + 1
              end
     
              local lineCount = select(2, text:gsub("\n", "\n"))

              local charOccurrencesWithoutSpaces = {}
              for char in text:gmatch("[%z\1-\127\194-\244][\128-\191]*") do
                if char ~= " " then
                  if not charOccurrencesWithoutSpaces[char] then
                    charOccurrencesWithoutSpaces[char] = 0
                  end
                  charOccurrencesWithoutSpaces[char] = charOccurrencesWithoutSpaces[char] + 1
                end
              end

              local mostFrequentCharWithoutSpacesCount = 0
              local mostFrequentCharWithoutSpaces
              for char, count in pairs(charOccurrencesWithoutSpaces) do
                if count > mostFrequentCharWithoutSpacesCount then
                  mostFrequentCharWithoutSpacesCount = count
                  mostFrequentCharWithoutSpaces = char
                end
              end

              local wordOccurrences = {}
              for word in text:gmatch("%S+") do
                if not wordOccurrences[word] then
                  wordOccurrences[word] = 0
                end
                wordOccurrences[word] = wordOccurrences[word] + 1
              end

              local topFiveWords = {}
              local sortedWords = {}
              for word, count in pairs(wordOccurrences) do
                table.insert(sortedWords, {word = word, count = count})
              end
              table.sort(sortedWords, function(a, b) return a.count > b.count end)
              for i, data in ipairs(sortedWords) do
                if i <= 5 then
                  table.insert(topFiveWords, data)
                else
                  break
                end     
              end

              return {
                charCount = charCount,
                charCountWithoutSpaces = charCountWithoutSpaces,
                wordCount = wordCount,
                lineCount = lineCount,
                mostFrequentCharWithoutSpaces = mostFrequentCharWithoutSpaces,
                mostFrequentCharWithoutSpacesCount = mostFrequentCharWithoutSpacesCount,
                topFiveWords = topFiveWords            }
              end

              function printResults(result)                
                print("عددُ الأَحْرُف (معَ المسافات): ", result.charCount)
                print("عَددُ الأَحْرُف (بدونِ مسافات): ", result.charCountWithoutSpaces)
                print("عددُ الكلمات: ", result.wordCount)
                print("عدد الأَسْطُر: ", result.lineCount)
                print("الحرفُ الأكثرُ تَكْرارا: ", result.mostFrequentCharWithoutSpaces, " (", result.mostFrequentCharWithoutSpacesCount, " مرة)")
                print("أكثرُ خمسِ كلماتٍ تَكْرارا:")
                for i, data in ipairs(result.topFiveWords) do
                  print(i .. ". " .. data.word .. " (تكررت " .. data.count .. " مرة)")
                end
              end

              function main()
                local result = analyzeText(text)
                printResults(result)
              end
            main{}
          end;
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      };
    }
    dlg = LuaDialog(this)
    dlg.setTitle("مُحَلِّلُ النص")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    elseif v.text == "حَجَرة ورقة مقص" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          Button;
          id = "rockButton",
          layout_width = "match_parent",
          layout_height = "wrap_content",
          text = "حَجَرة";
          onClick = function()
            local playerChoice = "حَجَرة"
            local choices = {"حَجَرة", "ورقة", "مقص"}
            local computerChoice = choices[math.random(1, 3)]
            local result = ""
            if playerChoice == computerChoice then
              result = "النتيجةُ هي: تعادل"
            elseif (playerChoice == "حَجَرة" and computerChoice == "مقص") then
              result = "لقد فُزْت"
            else
              result = "لقد خَسِرْت"
            end

            service.speak("لَقَد اخترت: " .. playerChoice .. ". اختارَ الجهاز: " .. computerChoice .. "." .. result)
          end;
        };
        {
          Button;
          id = "paperButton",
          layout_width = "match_parent",
          layout_height = "wrap_content",
          text = "ورقة",
          onClick = function()
            local playerChoice = "ورقة"
            local choices = {"حَجَرة", "ورقة", "مقص"}
            local computerChoice = choices[math.random(1, 3)]
            local result = ""
            if playerChoice == computerChoice then
              result = "النتيجةُ هي: تعادل"
            elseif (playerChoice == "ورقة" and computerChoice == "حَجَرة") then            
              result = "لقد فُزْت"
            else
              result = "لقد خَسِرْت"
            end     
            service.speak("لقد اخترت: " .. playerChoice .. ". اختارَ الجهاز: " .. computerChoice .. ". " .. result)
          end;
        };
        {
          Button;
          id = "scissorsButton",
          layout_width = "match_parent",
          layout_height = "wrap_content",
          text = "مقص",
          onClick = function()
            local playerChoice = "مقص"
            local choices = {"حَجَرة", "ورقة", "مقص"}
            local computerChoice = choices[math.random(1, 3)]
            local result = ""
            if playerChoice == computerChoice then
              result = "النتيجةُ هي: تعادل"
            elseif (playerChoice == "مقص" and computerChoice == "ورقة") then
              result = "لقد فُزْت"
            else
              result = "لقد خَسِرْت"
            end
            service.speak("لَقَد اخترت: " .. playerChoice .. ". اختارَ الجهاز: " .. computerChoice .. ". " .. result)
          end;
        };
        {
          Button;
          id = "exitButton",
          layout_width = "match_parent",
          layout_height = "wrap_content",
          text = "خروج",
          onClick = function()
            dlg.dismiss()
          end;
        };
      }
    dlg = LuaDialog(this)
    dlg.setTitle("حَجَرة ورقة مقص")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    elseif v.text == "الموسوعةُ الحديثية" then
      InputLayout = {
        LinearLayout;
        orientation = "vertical";
        {
          EditText;
          hint = "أُكْتُب عِبارةً مِنَ الحديثِ الذي تريدُ البحثَ عنه";
          id = "hadith";
          gravity = "right";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";          
        };
        {
          Button;
          text = "ابحث";
          onClick = function()
            local hadithText = hadith.text
            local url = "https://dorar.net/dorar_api.json?skey="..hadithText.."&callback=?"
            Http.get(url,function(status, data)
            if status == 200 then
              local modifiedData = modifyHtmlData(data)
              print(modifiedData)
            else
              print("حدث خطأ أثناء جلب البيانات")
            end
          end)
        end
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      }
    dlg = LuaDialog(this)
    dlg.setTitle("الموسوعةُ الحديثية")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    elseif v.text == "المِسْبَحةُ الإلكترونية" then
      local file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "r+")
      local lines = {}
      for line in file:lines() do
        table.insert(lines, line)
      end
      local count1 = tointeger(lines[1])
      local count2 = tointeger(lines[2])
      local count3 = tointeger(lines[3])
      local count4 = tointeger(lines[4])
      local count5 = tointeger(lines[5])
      local count6 = tointeger(lines[6])
      local count7 = tointeger(lines[7])
      local count8 = tointeger(lines[8])
      local count9 = tointeger(lines[9])
      local count10 = tointeger(lines[10])
      InputLayout = {
      ScrollView;
      {
        LinearLayout;
        orientation = "vertical";
        layout_width = "match_parent";
        {
          TextView;
          text = "سبحان الله";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn1";
          text = tostring(count1);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count1 = count1 + 1
            count_btn1.setText(tostring(count1))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count1 = 0
            count_btn1.setText(tostring(count1))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(0).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end
        };
        {
          TextView;
          text = "الحمد لله";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn2";
          text = tostring(count2);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count2 = count2 + 1
            count_btn2.setText(tostring(count2))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count2 = 0
            count_btn2.setText(tostring(count2))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(0).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))         
            file:close() 
          end;
        };
        {
          TextView;
          text = "لا إله إلا الله";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn3";
          text = tostring(count3);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count3 = count3 + 1
            count_btn3.setText(tostring(count3))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count3 = 0
            count_btn3.setText(tostring(count3))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(0).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          TextView;
          text = "الله أكبر";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn4";
          text = tostring(count4);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count4 = count4 + 1
            count_btn4.setText(tostring(count4))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count4 = 0
            count_btn4.setText(tostring(count4))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(0).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          TextView;
          text = "سبحان الله وبحمده سبحان الله العظيم";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn5";
          text = tostring(count5);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count5 = count5 + 1
            count_btn5.setText(tostring(count5))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
         end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count5 = 0
            count_btn5.setText(tostring(count5))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(0).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          TextView;
          text = "اللهم صلِّ وسلم وبارك على سيدنا محمد";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn6";
          text = tostring(count6);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count6 = count6 + 1
            count_btn6.setText(tostring(count6))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
         end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count6 = 0
            count_btn6.setText(tostring(count6))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(0).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          TextView;
          text = "اللهمَّ إنك عفوٌّ تُحبُّ العفوَ فاعفُ عنِّي";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn7";
          text = tostring(count7);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count7 = count7 + 1
            count_btn7.setText(tostring(count7))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
         end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count7 = 0
            count_btn7.setText(tostring(count7))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(0).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          TextView;
          text = "لا اله الا انت سبحانك إني كنت من الظالمين";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn8";
          text = tostring(count8);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count8 = count8 + 1
            count_btn8.setText(tostring(count8))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count8 = 0
            count_btn8.setText(tostring(count8))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(0).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          TextView;
          text = "سبحان الله وبحمده عدد خلقه ورضا نفسه وزنة عرشه ومداد كلماته";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn9";
          text = tostring(count9);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count9 = count9 + 1
            count_btn9.setText(tostring(count9))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count9 = 0
            count_btn9.setText(tostring(count9))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(0).."\n"..tonumber(count10))
            file:close() 
          end;
        };
        {
          TextView;
          text = "لا إله إلا الله وحدَهُ لا شريك له، لهُ الملكُ ولهُ الحمدُ وهو على كل شيء قدير";
          textSize = "20sp";
          textColor = "#d9d9d9";
          gravity = "center";
          layout_width = "match_parent";
          layout_height = "wrap_content";
        };
        {
          Button;
          id = "count_btn10";
          text = tostring(count10);
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count10 = count10 + 1
            count_btn10.setText(tostring(count10))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(count10))
            file:close()        
          end;
        };
        {
          Button;
          text = "تصفير";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            count10 = 0
            count_btn10.setText(tostring(count10))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(count1).."\n"..tonumber(count2).."\n"..tonumber(count3).."\n"..tonumber(count4).."\n"..tonumber(count5).."\n"..tonumber(count6).."\n"..tonumber(count7).."\n"..tonumber(count8).."\n"..tonumber(count9).."\n"..tonumber(0))
            file:close() 
          end;
        };
        {
          Button;
          text = "تصفير الكل";
          gravity = "center";
          layout_width = "match_parent";
          onClick = function()
            local count1 = 0
            local count2 = 0
            local count3 = 0
            local count4 = 0
            local count5 = 0
            local count6 = 0
            local count7 = 0
            local count8 = 0
            local count9 = 0
            local count10 = 0
            count_btn1.setText(tostring(count1))
            count_btn2.setText(tostring(count2))
            count_btn3.setText(tostring(count3))
            count_btn4.setText(tostring(count4))
            count_btn5.setText(tostring(count5))
            count_btn6.setText(tostring(count6))
            count_btn7.setText(tostring(count7))
            count_btn8.setText(tostring(count8))
            count_btn9.setText(tostring(count9))
            count_btn10.setText(tostring(count10))
            file = io.open("/storage/emulated/0/解说/Plugins/Tools Space, v2.0/azkar_count.txt", "w")
            file:write(tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0).."\n"..tonumber(0))
            file:close() 
          end;
        };
        {
          Button;
          text = "خروج";
          onClick = function()
            dlg.dismiss()
          end;
        };
      };
    }
    dlg = LuaDialog(this)
    dlg.setTitle("المِسْبَحةُ الإلكترونية")
    dlg.setView(loadlayout(InputLayout))
    dlg.show()
    end
  end)
end

function printHadiths(hadiths)
  for _, hadith in ipairs(hadiths) do
    print(hadith) 
  end   
end

function strip(s)
  return s:gsub("^%s*(.-)%s*$", "%1")
end
function modifyHtmlData(htmlData)
  local modifiedData = htmlData:gsub("<span[^>]*>(.-)</span>", " ")
  local startIndex = modifiedData:find("1%s-[-]")
  if startIndex then
      -- استخراج الجزء من النص بدءًا من الرقم 1
    modifiedData = modifiedData:sub(startIndex)
  end
  modifiedData = modifiedData:gsub("\\n", "\n")
  modifiedData = modifiedData:gsub('{', "")
  modifiedData = modifiedData:gsub('?', "")
  modifiedData = modifiedData:gsub('المزيد', "")
  modifiedData = modifiedData:gsub('---', "")
  modifiedData = modifiedData:gsub('( "ahadith"', "")
  modifiedData = modifiedData:gsub('(:"result":"', "")
  modifiedData = modifiedData:gsub("<.->", "")
  modifiedData = strip(modifiedData)
  modifiedData = modifiedData:gsub("\n\n+", "\n")
  local hadiths = {}
  for hadith in modifiedData:gmatch("(.-)\n") do
    table.insert(hadiths, hadith)
  end
  printHadiths(hadiths)
end

function showNew()
      InputLayout = {
      ScrollView;
      {
        LinearLayout;
        orientation = "vertical";
        layout_width = "match_parent";
        {
          TextView;
          text = "• الإصدار: 1.2.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• تاريخُ الإصدار: 19 أبريل/نيسان 2024.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "التعديلاتُ والتحسينات:";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• أصبحَ كودُ الإضافةِ أسهلَ في القِراءةِ والفَهْم، ونَعِدُكُم أنَّنا لن نُشَفِّرَهُ بحيثُ تستطيعونَ الاِستفادةَ والتَّعَلُّمَ مِنْه.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• عُدِّلَت طريقةُ عَرْضِ الأدواتِ والعناصَِرِ في الواجهةِ الرسومية لِتَتَوافَقَ معَ اللغةِ العربيةِ وذلك تسهيلاً على ضعيفي البَصر.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• عُدِّلَت كثيرٌ مِنَ الرسائِلِ والأخطاءِ مراعاةً للغةِ العربيةِ نحويّاً وإملائيّاً.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• يُمكِنُكَ الآنَ الضغطُ على زِرِّ خروجٍ في أيِّ أداةٍ وستختفي الأداةُ المَفتوحةُ فقط، دونَ الخروجِ مِن Tools Space بالكامل، هذا سيُسَهِّلُ التَّنَقُّلَ بينَ الأدواتِ واستخدامِها بِسُرعة.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        }; 
        {
          TextView;
          text = "• أضيفَ زِرٌّ جديدٌ فِيْ قائِمةِ Tools Space الرئيسيةِ واسمُهُ مُساعَدة، وفيهِ عناصِرُ قد تُفيدُكَ في التَّعَرُّفِ على الإضافةِ واستخدامِها اِستخداماً صحيحا.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
         {
          TextView;
          text = "• يُمكِنُكَ تغييرُ ترتيبِ الأدواتِ في هذا التَّحْديثِ بِناءً على اِحتياجاتِكَ عن طريقِ فتحِ قائمةِ المُساعَدة ثُمَّ تغييرِ ترتيبِ الأدوات.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        }; 
        {
          TextView;
          text = "• في الإصدارِ السابق، يُمْكِنُكَ كتابةُ نصٍّ في مُرَبَّعاتِ الكِتابةِ التي تطْلُبُ رقماً فقط، وهذا قد يُحدِثُ مشاكلَ عديدة، حُلَّ هذا الخطأُ الآن.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };  
        {
          TextView;
          text = "• أُضيفَ حقلٌ جديدٌ في أداةِ إنشاءِ رابطٍ لحسابِ WhatsApp، ألا وهوَ الرسالة، يُمكِنُ أن تكتُبَ أيَّ شيءٍ وَسَيَظْهَرُ في تطبيقِ WhatsApp عندَ مُراسَلةِ الرقمِ مُباشَرةً.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• حُلَّت مُشكِلةُ سَحْبِ الأسماءِ التي فيها مسافةٌ في القُرْعةِ العشوائية، ولكن يجِبُ الآنَ أن تَكْتُبَ الأسماءَ مَفْصولةً بِنُقاطٍ هكذا:\nمحمد. عمر. عبد الرحمن\nوستَعْمَلُ الأداةُ طبيعيّاً.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        }; 
        {
          TextView;
          text = "• يُمْكِنُكَ في هذا التحديثِ عملُ سَحْبٍ مُتَعَدِّدٍ في القُرْعةِ العشوائية، بحيثُ يُسْحَبُ الفائزُونَ بحَسَبِ العددِ الذي تُحَدِّدُه، فمثلا، إذا كانَ حقلُ الأسماءِ فيه:!\nمحمد. عمر. أُسامة. هاشم\nوعددُ الفائِزينَ 2، فسيُسْحَبُ اِسمانِ فقط، وَلْنَفْتَرِض أنَّهُما هاشمٌ ومحمد.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        }; 
        {
          TextView;
          text = "أدواتٌ جديدة:";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };  
        {
          TextView;
          text = "أضَفْنا سَبْعَ أدواتٍ جديدةٍ في هذا التَّحْديث، وهي:";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };  
        {
          TextView;
          text = "• إنشاءُ روابِطِ التحميلِ المُباشَرة، تُسْتَخْدَمُ لِتَحْوِيلِ روابِطِ Google Drive وَ DropBox إلى روابِطِ تحميلٍ تُنَزَّلُ في الجِهازِ فوراً عندَ الضغطِ عليها.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };   
        {
          TextView;
          text = "• مُحَوِّلُ التاريخ، تُسْتَخْدَمُ لِتَحْويلِ التاريخِ الميلادِيِّ إلى التاريخِ الهِجْري";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        }; 
        {
          TextView;
          text = "• حِسابُ العُمُر، تُسْتَخْدَمُ لِحِسابِ العُمُرِ حِساباً دقيقاً بالدقيقةِ والساعةِ واليومِ والشهرِ والعام.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• مُحَلِّلُ النص، تُسْتَخْدَمُ لِلْحُصُولِ على إحْصائيَّاتٍ دقيقةٍ حولَ النص، مِثْلَ عدَدِ الأحْرُفِ والكَلِمَاتِ والأسطُر، إلخ.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• حَجَرة ورقة مِقَص، لُعْبةٌ بسيطةٌ معروفة، لا تحتاجُ لِشَرْح، ولكن تُلْعَبُ هُنا معَ الجهازِ عشوائيّاً.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• المَوسوعةُ الحديثية، أداةٌ لِلْبَحْثِ عن أحاديثِ رسولِ الله صَلَّى الله عليهِ وسَلَّمَ والتَّحَقُّقِ مِن صَحَّتِها.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "• المِسْبَحَةُ الإلكترونية، أداةٌ تحتوي على بعضِ الأذكارِ المأخوذةِ مِنْ موقِعِ نافذةِ التقنية، ويُحْفَظُ عَدَدُ التسبيحاتِ الذي وَصَلْتَ إليهِ عِنْدَ الخُروجِ مِنَ الإضافة.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          TextView;
          text = "هذا كُلُّ شيءٍ في التَّحْديث، إذا وَجَدْتُم أيَّ أخطاءٍ أو لديكُم أيُّ اقتراحاتٍ فلا تَتَرَدَّدوا في التواصُلِ مَعَنا عبرَ حسابِ الدَّعْمِ على Telegram بالضَّغْطِ على الزِرِّ التالي.";
          textColor = "#ffffff";
          textSize = "16sp";
          gravity = "right";
          layout_width = "match_parent";
          layout_marginLeft = "11dp";          
          layout_marginRight = "16dp";
        };
        {
          Button;
          text = "تَواصَل مَعَنا";
          onClick = function()
            helpDialog.dismiss()
            this.startActivity(Intent(Intent.ACTION_VIEW, Uri.parse("https:/t.me/PlanetBlindTech")))
            service.click({{"%العودة"}})                       service.postClick(20, {{helpDialog.dismiss()}})

          end;
        };                                                                                                                                                                                                                      
        {
          Button;
          text = "خروج";
          onClick = function()
            helpDialog.dismiss()
          end;
        };
      };
    }
end

function changeToolsOrder()
  InputLayout = {
  ScrollView;
  {
    LinearLayout;
    orientation = "vertical";
    layout_width = "match_parent";
    {
      TextView;
      text = "مرحباً بِكَ عزيزي المُسْتَخْدِم، يُمْكِنُكَ تغييرُ ترتيبِ الأزرارِ مِن خِلالِ هذه النافذةِ بناءً على اِحتياجاتِك واستخدامِك.";
      textColor = "#ffffff";
      textSize = "16sp";
      gravity = "right";
      layout_width = "match_parent";
      layout_marginLeft = "11dp";          
      layout_marginRight = "16dp";
    }; 
    {
      TextView;
      text = "• لِتَغييرِ ترتيبِ الأدوات، اضغط على اِسمِ الأداةِ ورَتِّبْ جميعَ الأدواتِ كيفَما تشاءُ ثُمَّ اضغط إعادةَ الترتيب.";          
      textColor = "#ffffff";
      textSize = "16sp";
      gravity = "right";
      layout_width = "match_parent";
      layout_marginLeft = "11dp";
      layout_marginRight = "16dp";
    }; 
    {
      TextView;
      text = "• إذا أخطأْتَ في تَرْتيبِ الأدوات، اضْغَط على زِرِّ إعادةِ التعيينِ الموجودِ في الأسفل، وَسَيُعادُ تفعيلُ الأزرارِ وسيُحْذَفُ كُلُّ شيءٍ مِن مُرَبَّعِ الكِتابة.";
      textColor = "#ffffff";
      textSize = "16sp";
      gravity = "right";
      layout_width = "match_parent";
      layout_marginLeft = "11dp";
      layout_marginRight = "16dp";
    };       
    {                         
      Button;          
      text = "إنشاءُ رابطٍ لِحسابِ Telegram";
      id = "o1";
      gravity = "center";
      layout_width = "match_parent";
      onClick = function()
        order.append('  "إنشاءُ رابطٍ لِحسابِ Telegram",\n')
        o1.enabled = false
      end                   
    }; 
    {               
      Button;          
      text = "إنشاءُ رابطٍ لِحسابِ WhatsApp";
      id = "o2";
      gravity = "center";
      layout_width = "match_parent";          
      gravity = "center";
      onClick = function()
        order.append('  "إنشاءُ رابطٍ لِحسابِ WhatsApp",\n')
        o2.enabled = false
      end                   
    };
    {               
      Button;              
      text = "إنشاءُ روابِطِ التحميلِ المُباشَرة";
      id = "o3";
      gravity = "center";
      layout_width = "match_parent";         
      gravity = "center";
      onClick = function()        
        order.append('  "إنشاءُ روابِطِ التحميلِ المُباشَرة",\n')
        o3.enabled = false
      end                   
    };
    {               
      Button;          
      text = "أحوالُ الطقس";
      id = "o4";
      gravity = "center";
      layout_width = "match_parent";          
      gravity = "center";
      onClick = function()
        order.append('  "أحوالُ الطقس",\n')
        o4.enabled = false
      end                   
    };
    {                  
      Button;          
      text = "نَسْخُ رابطِ التطبيقِ المَفتوحِ إلى الحافِظة";
      id = "o5";
      gravity = "center";
      layout_width = "match_parent";          
      gravity = "center";
      onClick = function()
        order.append('  "نَسْخُ رابطِ التطبيقِ المَفتوحِ إلى الحافِظة",\n')
        o5.enabled = false
      end                   
    }; 
    {               
      Button; 
      text = "مُوَلِّدُ كلماتِ المرور";        
      id = "o6";
      gravity = "center";
      layout_width = "match_parent";             
      gravity = "center";
      onClick = function()
        order.append('  "مُوَلِّدُ كلماتِ المرور",\n')
        o6.enabled = false
      end                   
    };
    {               
      Button;          
      text = "مُحَوِّلُ التاريخ";
      id = "o7";
      gravity = "center";
      layout_width = "match_parent";
      onClick = function()
        order.append('  "مُحَوِّلُ التاريخ",\n')
        o7.enabled = false
      end                   
    };
    {               
      Button;          
      text = "القُرْعةُ العشوائية";
      id = "o8";
      gravity = "center";
      layout_width = "match_parent";                 
      onClick = function()
        order.append('  "القُرْعةُ العشوائية",\n')
        o8.enabled = false
      end                   
    };
    {                  
      Button;          
      text = "حِسابُ العُمُر";
      id = "o9";
      gravity = "center";
      layout_width = "match_parent";          
      onClick = function()
        order.append('  "حِسابُ العُمُر",\n')
        o9.enabled = false
      end                   
    }; 
    {               
      Button;          
      text = "مُحَلِّلُ النص";
      id = "o10";
      gravity = "center";
      layout_width = "match_parent";          
      onClick = function()
        order.append('  "مُحَلِّلُ النص",\n')
        o10.enabled = false
      end                   
    };
    {               
      Button;          
      text = "حَجَرة ورقة مقص";
      id = "o11";
      gravity = "center";
      layout_width = "match_parent";          
      onClick = function()        
        order.append('  "حَجَرة ورقة مقص",\n')
        o11.enabled = false
      end                   
    };
    {               
      Button;          
      text = "الموسوعةُ الحديثية";
      id = "o12";
      gravity = "center";
      layout_width = "match_parent";          
      onClick = function()
        order.append('  "الموسوعةُ الحديثية",\n')
        o12.enabled = false
      end                   
    };
    {               
      Button;          
      text = "المِسْبَحةُ الإلكترونية";
      id = "o13";
      gravity = "center";
      layout_width = "match_parent";         
      onClick = function()
        order.append('  "المِسْبَحةُ الإلكترونية",\n')
        o13.enabled = false
      end                   
    };                      
    {
      EditText;
      hint = "أعِد ترتيبَ الأدواتِ هنا";
      id = "order";
      gravity = "right";
      layout_width = "match_parent";
      layout_marginLeft = "11dp";
      layout_marginRight = "16dp";
    };                            
    {                 
      Button;          
      text = "إعادةُ الترتيب";
      onClick = function()                     
        local newOrder = order.text                        
        local filename = "storage/emulated/0/解说/Plugins/Tools Space, v2.0/main.lua"           
        local lines_to_remove = {30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42}
        local file = io.open(filename, "r")            
        local lines = {}           
        for line in file:lines() do
          table.insert(lines, line)
        end
        file:close()
        for i = #lines_to_remove, 1, -1 do
          table.remove(lines, lines_to_remove[i])
        end
        local new_filename = "storage/emulated/0/解说/Plugins/Tools Space, v2.0/main.lua"
        local new_file = io.open(new_filename, "w")            
        for _, line in ipairs(lines) do
          new_file:write(line .. "\n")
        end
        new_file:close()
        file = io.open("storage/emulated/0/解说/Plugins/Tools Space, v2.0/main.lua", "r+")
        local lines = {}
        local lineNumber = 1
        for line in file:lines() do
          if lineNumber == 30 then
            table.insert(lines, newOrder)
          else
            table.insert(lines, line)
          end
          lineNumber = lineNumber + 1
        end
        file:close()
        file = io.open("storage/emulated/0/解说/Plugins/Tools Space, v2.0/main.lua", "w")
        for _ , line in ipairs(lines) do
          file:write(line .. "\n")
        end
        file:close()
      end
    };
    {
      Button;
      text = "إعادةُ التعيين";
      onClick = function()
        order.text = ""
        o1.enabled = true
        o2.enabled = true
        o3.enabled = true
        o4.enabled = true
        o5.enabled = true
        o6.enabled = true
        o7.enabled = true
        o8.enabled = true
        o9.enabled = true
        o10.enabled = true
        o11.enabled = true
        o12.enabled = true
        o13.enabled = true
      end
    };
    {
      Button;
      text = "خروج";
      onClick = function()
        helpDialog.dismiss()
      end
    };
  };
}  
end
